### XCaLiBeR.cmds.tcl v1.0 for Eggdrop v1.0 Beta Stegosaurus or above
### Written by Apollo
### Greetings to HyDraS and PheniX (creator of XCaLiBeR for mIRC v4.0)
### Read the README.1st (DOS) or the README.UNIX (Unix) first

bind dcc m resynch dccresynch
bind msg - IDENT ident
bind msgm - "*" opgot
bind pub - !whois laston
bind pub - !status status
bind pub - !invite invite
bind pub o !idle getidle
bind pub o !ircops ircopslist
bind pub o !advertise advertise
bind pub m !jump jservers
bind pub m !resynch resynch
bind pub m !unkick unkick
bind pub m !del remove
bind pub m !users userl
bind part - "#xcaliber *" parting
bind sign - "#xcaliber *" partmsg

set daircops "/home/mydir/eggdrop/scripts/ircops"

proc partmsg {nick uhost handle channel reason} {
     global botnick
     if {$nick == $botnick} {
     } else {
       if {$handle == ""} {
       } else {
         setxtra $handle $reason
         setlaston $handle
         save 
      }
     }  
}

proc parting {nick uhost handle channel} {
     global botnick
        if {$nick == $botnick} {
        } else {
          if {$handle == ""} {
        } else {
          setxtra $handle "XCaLiBeR:  No Reason Given For Leaving $channel."
          setlaston $handle
          save
        }
       }
} 

proc laston {nick uhost handle channel args} {
     global botnick
     if {[validuser $args] == 0} {
        putserv "PRIVMSG $channel :$args is not known user on $botnick."
        putserv "PRIVMSG $channel :Make sure that is the user's handle."
     } else {
        set lastime [getlaston $args]
        set host [gethosts $args]
        set info [getinfo $args]
        set email [getemail $args]
        set signoffmsg [getxtra $args]
        putserv "PRIVMSG $channel :---"
        putserv "PRIVMSG $channel :Handle:  $args"
        putserv "PRIVMSG $channel :Known Hosts:  $host"
        if {$info == ""} {
        } else {
          putserv "PRIVMSG $channel :Information:  $info"
        }
        if {$email == ""} {
        } else {      
        putserv "PRIVMSG $channel :E-mail Address:  $email"
        }
        if {[hand2nick $args $channel] == ""} {
          putserv "PRIVMSG $channel :Last Time $args was seen in $channel:  [ctime $lastime]"
          if {$signoffmsg == ""} {
          } else {
              putserv "PRIVMSG $channel :Reason For Signing Off:  $signoffmsg"
          }
        } else {
          set hander [hand2nick $args $channel]
          putserv "PRIVMSG $channel :$args is on as $hander."
          if {[getchanidle $hander $channel] == 0} {
          } else {
            putserv "PRIVMSG $channel :Idle Time:  [getchanidle $hander $channel] minutes"
          }
        }
        if {[matchattr $args m] == 1} {
           putserv "PRIVMSG $channel :$args is a master on $botnick."
        } 
        putserv "PRIVMSG $channel :-----"
     }
 }

proc unkick {nick uhost handle channel args} {
    global botnick
    if {$nick == $botnick} {
    } else {
      if {[validuser $args] == 0} {
         putserv "PRIVMSG $nick :$args is not a valid user."
      } else {
        if {[matchattr $args k] == 1} {
           set comment [getcomment $args]
           chattr $args -k
           setcomment $args ""
           save
           putserv "PRIVMSG $nick :$args is no longer being kicked for $comment."
        } else {
          putserv "PRIVMSG $nick :$args does not have the +k flag."
        }
      }
    }
 }


proc unkick {nick uhost handle channel args} {
    global botnick
    if {$nick == $botnick} {
    } else {
      if {[validuser $args] == 0} {
         putserv "PRIVMSG $nick :$args is not a valid user."
      } else {
        if {[matchattr $args k] == 1} {
           set comment [getcomment $args]
           chattr $args -k
           setcomment $args ""
           save
           putserv "PRIVMSG $nick :$args is no longer being kicked for $comment."
        } else {
          putserv "PRIVMSG $nick :$args does not have the +k flag."
        }
      }
    }
 }

proc invite {nick uhost handle channel args} {
   global botnick
   if {$nick == $botnick} {
   } else {
     if {[string toupper $args] == [string toupper $botnick]} {
        putserv "PRIVMSG $nick :I can't invite myself."
     } else {
       if {[onchan $args $channel] == 1} {
          putserv "PRIVMSG $nick :$args is already on $channel."
       } else {
          putserv "INVITE $args $channel"
          putserv "PRIVMSG $nick :$args has been invited to $channel."
          if {[matchattr $handle m] == 1} {
             if {[matchattr $args k] == 1} {
                chattr $args -k
                save 
                putserv "PRIVMSG $nick :$args no longer has the +k flag."
             }
          }
       }
     }
   }
 }

proc ident {nick uhost handle args} {
    if {[validuser $nick] == 0} {
       putserv "PRIVMSG $nick :You are not a valid user."
       putserv "PRIVMSG $nick :If you are a valid user changer yer nick to yer handle."
    } else {
      if {[passwdok $nick $args] == 0} {
         putserv "PRIVMSG $nick :That password you entered is not valid."
         putserv "PRIVMSG $nick :Make sure you enter the right password or you have a password set."
      } else {
         addhost $nick [maskhost $uhost]
         save
         putserv "PRIVMSG $nick :[maskhost $uhost] has been added as one of your hosts."
      }
    }
 }

proc getidle {nick uhost handle channel args} {
     global botnick
     if {$args == "{}"} {
        putserv "PRIVMSG $channel :You ($nick) have been idle for [getchanidle $nick $channel] minutes."
     } else {
     if {[string toupper $nick] == [string toupper $botnick]} {
     } else {
       if {[onchan $args $channel] == 0} {
          putserv "PRIVMSG $channel :$args is not on $channel."
       } else {
       if {[string toupper $args] == [string toupper $botnick]} {
          putserv "PRIVMSG $channel :Why do you care how long I have been idle?"
          putserv "PRIVMSG $channel :If you must know, I have been IDLE for [getchanidle $args $channel] minutes."
       } else {
         if {[string toupper $args] == [string toupper $nick]} {
            putserv "PRIVMSG $channel :You ($nick) have been idle for [getchanidle $args $channel] minutes."
         } else {
            putserv "PRIVMSG $channel :$args has been idle for [getchanidle $args $channel] minutes."
         }
       }
       }
       }
      }
 }

proc ircopslist {nick uhost handle channel args} {
  global botnick daircops
  set exits "0"
  if {$args == "{}"} {
     set idz [open $daircops r]
     putserv "PRIVMSG $channel : "
     putserv "PRIVMSG $channel :------- Known IRC Operator Hosts --------"
     while {[eof $idz] == 0} { 
     gets $idz theops
     putserv "PRIVMSG $channel :$theops"
    }
    close $idz
    putserv "PRIVMSG $channel :---------- End Of Operator List ----------"
    putserv "PRIVMSG $channel : "
  } else {
    set idz [open $daircops a]
    set theid [open $daircops r]
    while {[eof $theid] == 0} {
    gets $theid hosts
    if {[string compare [string toupper $hosts] [string toupper $args]] == 0} {
       putserv "PRIVMSG $channel :$args is already on the IRCOp List."
       set exits "1"
       break
      }
    }
    if {$exits == "1"} {
       break
    }
    puts $idz $args
    close $theid
    close $idz
    putserv "PRIVMSG $channel :$args has been added to the IRCOPS list."
  }
}

proc opgot {nick uhost handle text} {
     global botnick daircops
     if {$nick == $botnick} {
     } else {
       set id [open $daircops r]
       while {[eof $id] == 0} {
        gets $id hosts
        if {[string toupper $hosts] == [maskhost [string toupper $uhost]]} {
           putlog "An IRCOp PRIVMSGed Me with the nick: $nick and the uhost: $uhost."
           jump
           break
        }
       }
     }
 }

proc resynch {nick uhost handle channel args} {
   global botnick
   set ppl [chanlist $channel]
   putserv "mode $channel +i"
   foreach stuff $ppl {
     if {$stuff == $botnick} {
     } else {
      putserv "KICK $channel $stuff Resynching"
     }
   }
  set dabans [chanbans $channel]
  foreach banns $dabans {
    putserv "mode $channel -b $banns"
  }

utimer 20 [undo $ppl $dabans $channel]

}

proc dccresynch {handle idx args} {
    global botnick
    if {$args == "{}"} {
       putdcc $idx "Arguments are resynch <channel>"
    } else {
      set ppl [chanlist $args]
      putdcc $idx "Resynching $args."
      putserv "mode $args +i"
      foreach stuff $ppl {
        if {$stuff == $botnick} {
        } else {
          putserv "KICK $args $stuff Resynching"
        }
      }
      set dabans [chanbans $args]
      foreach banns $dabans {
        putserv "mode $args -b $banns"
     }
      utimer 20 [undo $ppl $dabans $args]
   }
 }

proc undo {users bans channel} {
  foreach ah $bans {
    putserv "mode $channel +b $ah"
  }
  putserv "mode $channel -i"

  foreach h $users {
    putserv "INVITE $h $channel"
  }	
}

proc status {nick uhost handle channel args} {
     global botname server version botnick
     putserv "PRIVMSG $channel :--------------- $botnick ---------------"
     putserv "PRIVMSG $channel :            Eggdrop $version"
     putserv "PRIVMSG $channel :Current Date/Time: [date] [time]"
     putserv "PRIVMSG $channel :Channels:  [channels]"
     putserv "PRIVMSG $channel :Current nick!user@host: $botname"
     putserv "PRIVMSG $channel :DCC IP Address:  [myip]"
     putserv "PRIVMSG $channel :Current Server: $server"
     putserv "PRIVMSG $channel :$botnick contains a record of [countusers] users."
     set owners [userlist n]
     putserv "PRIVMSG $channel :Owner(s):"
     foreach owns $owners {
     putserv "PRIVMSG $channel :   $owns" 
     }
     putserv "PRIVMSG $channel :-----------------------------------------"
}


proc userl {nick uhost handle channel args} {
    set userid "0"
    if {$args == "{}"} {
    foreach userd [userlist] {
    if {$userd == "*ignore"} {
    } else {
      if {$userd == "*ban"} {
      } else {
    set userid [expr $userid + 1]
    putserv "PRIVMSG $nick :HANDLE:  $userd  ($userid/[expr [countusers] - 2])"
    putserv "PRIVMSG $nick :HOSTMASK (S):  [gethosts $userd]"
    if {[passwdok $userd "none"] == 1} {
      putserv "PRIVMSG $nick :PASS: no"
    } else {
      putserv "PRIVMSG $nick :PASS: yes"
    }
    putserv "PRIVMSG $nick :ATTR: [chattr $userd]"
    if {[getlaston $userd] == "0"} {  
       putserv "PRIVMSG $nick :LAST: never"
    } else {
       putserv "PRIVMSG $nick :LAST: [ctime [getlaston $userd]]"
    }
    if {[getcomment $userd] == ""} {
    } else {
      putserv "PRIVMSG $nick :COMMENT: [getcomment $userd]"
    }
    if {[getemail $userd] == ""} {
    } else {
      putserv "PRIVMSG $nick :EMAIL: [getemail $userd]"
    }
    if {[getinfo $userd] == ""} {
    } else {
      putserv "PRIVMSG $nick :INFO: [getinfo $userd]"
    }
      putserv "PRIVMSG $nick :   " 
    }
    }
    }
    } else {
    if {[validuser $args] == 1} {
    putserv "PRIVMSG $nick :HANDLE:  $args"
    putserv "PRIVMSG $nick :HOSTMASK (S):  [gethosts $args]"
    if {[passwdok $args "none"] == 1} {
      putserv "PRIVMSG $nick :PASS: no"
    } else {
      putserv "PRIVMSG $nick :PASS: yes"
    }
    putserv "PRIVMSG $nick :ATTR: [chattr $args]"
    if {[getlaston $args] == "0"} {
       putserv "PRIVMSG $nick :LAST: never"
    } else {
       putserv "PRIVMSG $nick :LAST: [ctime [getlaston $args]]"
    }
  if {[getcomment $args] == ""} {
    } else {
      putserv "PRIVMSG $nick :COMMENT: [getcomment $args]"
    }
    if {[getemail $args] == ""} {
    } else {
      putserv "PRIVMSG $nick :EMAIL: [getemail $args]"
    }
    if {[getinfo $args] == ""} {
    } else {
      putserv "PRIVMSG $nick :INFO: [getinfo $args]"
    }
    } else {
      putserv "PRIVMSG $nick :$args is not a valid user."
    }
}
}

proc jservers {nick uhost handle channel args} {
    global botnick server
    set oldserv $server
    if {$nick == $botnick} {
    } else {
      if {$args == "{}"} {
         jump
         putserv "PRIVMSG $nick :Jumped from $oldserv to $server."
      } else {
         jump $args
         putserv "PRIVMSG $nick :Jumping from $oldserv to $args." 
      }
    }
 }


proc remove {nick uhost handle channel args} {
     global botnick
     if {$nick == $botnick} {
     } else {
     if {$handle == $args} {
      putserv "PRIVMSG $nick :You can't delete yourself from here.  Do it manually from the party line."
     } else {
     if {[matchattr $args m] == 1} {
       putserv "PRIVMSG $nick :You can't delete a master."
     } else {
     if {$args == "{}"} {
      putserv "PRIVMSG $nick :The correct arguments are !del <handle>."
     } else { 
      if {[validuser $args] == 1} {
          if {[deluser $args] == 1} {
            save
            putserv "PRIVMSG $nick :$args was removed succesfully."          
          } else {
            putserv "PRIVMSG $nick :$args was not deleted successfully.  Try deleting this user manually."
          }
      } else {
          putserv "PRIVMSG $nick :$args is not a valid user."
      }
     }
     }
     }
     }
 }

proc advertise {nick uhost handle channel args} {
     global botnick
     putserv "PRIVMSG $channel :XCaLiBeR, The TCL, v1.0 by Apollo == New Generation Addon for the Eggdrop v1.0 =="
     foreach dumbass [chanlist $channel] {
       if {$dumbass == $botnick} {
       } else {
       putserv "PRIVMSG $dumbass :XCaLiBeR, The TCL, v1.0 == New Generation Addon for the Eggdrop v1.0 =="
       putserv "PRIVMSG $dumbass :Join #XCaLiBeR on EfNet to receive the latest updates of XCaLiBeR, The TCL, and others."
       }
     } 
 }
